#ifndef HS_DATATYPE_H
#define HS_DATATYPE_H

/***
version: V1.1.2.22
note: HSDataType.h汾API̬汾޹

V1.1.2.13ͷļAPI汾Ҫ£
  FutuFPC1.0-APIV202023A-00-003()
  nsq1.0-api.V202201.01.000()
V1.1.2.6ͷļAPI汾Ҫ£
  FutuFPC1.0-APIV202024.00.000() 
  nsq1.0-api.V202001.13.002()

***/

#ifdef _WIN32

typedef char				int8;
typedef short				int16;
typedef int					int32;
typedef __int64				int64;
typedef unsigned char		uint8;
typedef unsigned short		uint16;
typedef unsigned int		uint32;
typedef unsigned __int64	uint64;

#else

#include <sys/types.h>

#if defined(__linux__)
#include <stdint.h>
#endif

typedef int8_t				int8;
typedef int16_t				int16;
typedef int32_t				int32;
typedef int64_t				int64;
typedef uint8_t				uint8;
typedef uint16_t			uint16;
typedef uint32_t			uint32;
typedef uint64_t			uint64;

#endif

//////////////////////////////////////////////////////////////////////////
/// HSInstrumentIDԼ
//////////////////////////////////////////////////////////////////////////
typedef char HSInstrumentID[81];

//////////////////////////////////////////////////////////////////////////
/// HSOptionsTypeȨ
//////////////////////////////////////////////////////////////////////////
/// ǣϹ
#define HS_OT_CallOptions  'C'
/// Ϲ
#define HS_OT_PutOptions   'P'
typedef char HSOptionsType;

//////////////////////////////////////////////////////////////////////////
/// HSExerciseStyleȨȨʽ
//////////////////////////////////////////////////////////////////////////
/// ʽȨ 
#define HS_American_Options  'A'
/// ŷʽȨ
#define HS_European_Options   'E'
typedef char HSExerciseStyle;

//////////////////////////////////////////////////////////////////////////
/// HSExchangeID
//////////////////////////////////////////////////////////////////////////
/// Ϻ֤ȯ
#define HS_EI_SSE                   "1"
/// ֤ȯ
#define HS_EI_SZSE                  "2"
/// ֤ȯ
#define HS_EI_BJSE                  "3"
/// ָг
#define HS_EI_SWI                  	"8"
/// ȫתתA
#define HS_EI_TZASE                 "9"
/// ͨ
#define HS_EI_SHHKSE                "G"
/// ͨ
#define HS_EI_SZHKSE                "S"
/// ֣Ʒ
#define HS_EI_CZCE                  "F1"
/// Ʒ
#define HS_EI_DCE                   "F2"
/// Ϻڻ
#define HS_EI_SHFE                  "F3"
/// йڻ
#define HS_EI_CFFEX                 "F4"
/// ϺԴĹɷ޹˾
#define HS_EI_INE                   "F5"
/// ڻ
#define HS_EI_GFEX                  "F6"
/// ͨ
#define HS_EI_SSEHK                 "G"
/// ͨ
#define HS_EI_SZSEHK                "S"
typedef char HSExchangeID[5];

//////////////////////////////////////////////////////////////////////////
/// HSInstrumentNameԼ
////////////////////////////////////////////////////////////////////////// 
typedef char HSInstrumentName[129];

//////////////////////////////////////////////////////////////////////////
/// HSVolume(double)
////////////////////////////////////////////////////////////////////////// 
typedef double HSVolume;

//////////////////////////////////////////////////////////////////////////
/// HSIntVolume(int64)
////////////////////////////////////////////////////////////////////////// 
typedef int64 HSIntVolume;

//////////////////////////////////////////////////////////////////////////
/// HSNum64
////////////////////////////////////////////////////////////////////////// 
typedef int64 HSNum64;

//////////////////////////////////////////////////////////////////////////
/// HSArbitPositionIDֲֺ
////////////////////////////////////////////////////////////////////////// 
typedef char HSArbitPositionID[32];

//////////////////////////////////////////////////////////////////////////
/// HSLegIDȺ
////////////////////////////////////////////////////////////////////////// 
typedef double HSLegID;

//////////////////////////////////////////////////////////////////////////
/// HSConfigNoñ
////////////////////////////////////////////////////////////////////////// 
typedef double HSConfigNo;

//////////////////////////////////////////////////////////////////////////
/// HSConfigValueÿ״̬
/// ݲͬñţвֵͬ
////////////////////////////////////////////////////////////////////////// 
typedef char HSConfigValue[128];

//////////////////////////////////////////////////////////////////////////
/// HSExerciseTypeȨȨ
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_ET_Abandon '0'
/// ִ
#define HS_ET_Exec    '1'
typedef char HSExerciseType;

//////////////////////////////////////////////////////////////////////////
/// HSPrice۸
////////////////////////////////////////////////////////////////////////// 
typedef double HSPrice;

//////////////////////////////////////////////////////////////////////////
/// HSBalance
////////////////////////////////////////////////////////////////////////// 
typedef double HSBalance;

//////////////////////////////////////////////////////////////////////////
/// HSSeqNo
////////////////////////////////////////////////////////////////////////// 
typedef int64 HSSeqNo;

//////////////////////////////////////////////////////////////////////////
/// HSDate ʽYYYYMMDD
////////////////////////////////////////////////////////////////////////// 
typedef int32 HSDate;

//////////////////////////////////////////////////////////////////////////
/// HSMsgContentϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSMsgContent[256];

//////////////////////////////////////////////////////////////////////////
/// HSCombStrategyIDϲԱ
//////////////////////////////////////////////////////////////////////////
/// Ϲţм۲
#define HS_CSI_CNSJC  "CNSJC"
/// Ϲм۲
#define HS_CSI_PXSJC  "PXSJC"
/// Ϲţм۲
#define HS_CSI_PNSJC  "PNSJC"
/// Ϲм۲
#define HS_CSI_CXSJC  "CXSJC"
/// ʽͷ
#define HS_CSI_KS     "KS"
/// ʽͷ
#define HS_CSI_KKS    "KKS"
/// ͨת
#define HS_CSI_ZBD    "ZBD"
/// תͨ
#define HS_CSI_ZXJ    "ZXJ"
typedef char HSCombStrategyID[9];

/////////////////////////////////////////////////////////////////////////
/// HSRemarksע
/////////////////////////////////////////////////////////////////////////
typedef char HSRemarks[256];

/////////////////////////////////////////////////////////////////////////
/// HSDirection
/////////////////////////////////////////////////////////////////////////
/// 
#define HS_DC_Buy     '1'
/// 
#define HS_DC_Sell    '2'
/// 
#define HS_DC_Loan    'F'
/// 
#define HS_DC_Borrow  'G'
typedef char HSDirection;

/////////////////////////////////////////////////////////////////////////
/// HSOrderDirection
/////////////////////////////////////////////////////////////////////////
/// 
#define HS_OD_Buy            1
/// 					    
#define HS_OD_Sell           2
/// ¹깺(ծ깺)			    
#define HS_OD_Apply          3
/// 				      
#define HS_OD_MarthSecu      4
/// ծȯת
#define HS_OD_BondConv		 5
/// ծȯ
#define HS_OD_BondCall		 6
/// Ѻ		        
#define HS_OD_PledgeIn       7
/// Ѻ		        
#define HS_OD_PledgeOut      8
/// ع				     
#define HS_OD_Repos          9
/// ع				     
#define HS_OD_ReverseRepos   10
/// ETFϹ				     
#define HS_OD_EtfSubs        11
/// ETF깺			  	    
#define HS_OD_EtfPur         12
/// ETF			  	    
#define HS_OD_EtfRed         13
/// ծȯ۳
#define HS_OD_BondCallCan	 14
/// LOFϹ			  	    
#define HS_OD_LofSubs        16
/// LOF깺			  	    
#define HS_OD_LofPur         17
/// LOF			  	    
#define HS_OD_LofRed         18
/// LOFתй			  	    
#define HS_OD_LofTrams       19
/// ּ		      
#define HS_OD_FundSplit      20
/// ּϲ		      
#define HS_OD_FundMerger     21
/// ּת		      
#define HS_OD_FundConv       22
/// һ깺
#define HS_OD_CurrFundPur    23
/// һ
#define HS_OD_CurrFundRed    24
/// Ʒ		   	    
#define HS_OD_CreditBuy      33
/// Ʒ		   	    
#define HS_OD_CreditSell     34
/// Ʒύ			    
#define HS_OD_CollateralIn   35
/// Ʒ			    
#define HS_OD_CollateralOut  36
/// 		        
#define HS_OD_MarginBuy      37
/// ȯ		        
#define HS_OD_ShortSell      38
/// ȯ		        
#define HS_OD_SellRepay      39
/// ȯȯ		        
#define HS_OD_BuyRepay       40
/// ȯȯ		        
#define HS_OD_HoldRepay      41
/// ۹
#define HS_OD_HkBuyRound     42
/// ۹
#define HS_OD_HkSellRound    43
/// ۹
#define HS_OD_HkSellOddLot   44
/// һ깺
#define HS_OD_CBPOF_OFC      45
/// һ
#define HS_OD_CBPOF_OFR      46
/// REITsϹ
#define HS_OD_ReitsFundSubs  47
/// ڻϹ
#define HS_OD_OFundSubs      48
/// ȯ
#define HS_OD_BorrowSell     49
typedef int32 HSOrderDirection;

/////////////////////////////////////////////////////////////////////////
/// HSOffsetFlagƽ־
/////////////////////////////////////////////////////////////////////////
/// 
#define HS_OF_Open       '1'
/// ƽ
#define HS_OF_Close      '2'
/// 
#define HS_OF_Delivery   '3'
/// ƽ
#define HS_OF_CloseToday '4'
/// ϵƽ
#define HS_OF_CloseSingle '6'
typedef char HSOffsetFlag;

/////////////////////////////////////////////////////////////////////////
/// HSCombDirectionָ
/////////////////////////////////////////////////////////////////////////
/// 
#define HS_CD_Comb            '1'
/// 
#define HS_CD_UnComb          '2'
typedef char HSCombDirection;

//////////////////////////////////////////////////////////////////////////
/// HSRef
//////////////////////////////////////////////////////////////////////////
typedef char HSRef[33];

//////////////////////////////////////////////////////////////////////////
/// HSTimeʱ ʽHHMMSSFFF
//////////////////////////////////////////////////////////////////////////
typedef int32 HSTime;

//////////////////////////////////////////////////////////////////////////
/// HSDurationTimeܺʱ
//////////////////////////////////////////////////////////////////////////
typedef int32 HSDurationTime;

/////////////////////////////////////////////////////////////////////////
/// HSPositionTypeֲ
/////////////////////////////////////////////////////////////////////////
/// Ȩ
#define HS_PT_Right                 '0'
/// 
#define HS_PT_Voluntary             '1'
/// ҷ
#define HS_PT_Covered               '2'
typedef char HSPositionType;

/////////////////////////////////////////////////////////////////////////
/// HSLockType
/////////////////////////////////////////////////////////////////////////
/// 
#define HS_LT_Lock           '1'
/// 
#define HS_LT_Unlock         '2'
typedef char HSLockType;

/////////////////////////////////////////////////////////////////////////
/// HSOrderStatus״̬
/////////////////////////////////////////////////////////////////////////
/// δ
#define HS_OS_NotReported                   '0'
/// 
#define HS_OS_ToBeReported                  '1'
/// ѱ
#define HS_OS_Reported                      '2'
/// ѱ
#define HS_OS_ReportedToBeCancel            '3'
/// ɴ
#define HS_OS_PartsTradedToBeCancel         '4'
/// 
#define HS_OS_CanceledWithPartsTraded       '5'
/// ѳ
#define HS_OS_Canceled                      '6'
/// 
#define HS_OS_PartsTraded                   '7'
/// ѳ
#define HS_OS_Traded                        '8'
/// ϵ
#define HS_OS_Abandoned                     '9'
/// 
#define HS_OS_CancelFailed                  'D'
/// ȷϴ
#define HS_OS_ConfirmedToBeCancel			'U'
/// ȷ
#define HS_OS_Confirmed                     'V'
/// ȷ
#define HS_OS_ToBeConfirmed                 'W'
typedef char HSOrderStatus;

//////////////////////////////////////////////////////////////////////////
/// HSErrorID
//////////////////////////////////////////////////////////////////////////
typedef int32 HSErrorID;

//////////////////////////////////////////////////////////////////////////
/// HSErrorMsgϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSErrorMsg[256];

/////////////////////////////////////////////////////////////////////////
/// HSOrderSource
/////////////////////////////////////////////////////////////////////////
/// Ͷ߷
#define HS_OSRC_Personal                '0'
/// 
#define HS_OSRC_Exchange                '1'
/// Ա
#define HS_OSRC_Member                  '2'
/// Ͷ߷
#define HS_OSRC_Organization            '3'
/// Ӫ׷
#define HS_OSRC_Proprietary             '4'
/// Էṩ̷
#define HS_OSRC_MobileServiceProvider   '5'
typedef char HSOrderSource;

//////////////////////////////////////////////////////////////////////////
/// HSTradeIDɽ
//////////////////////////////////////////////////////////////////////////
typedef char HSTradeID[32];

//////////////////////////////////////////////////////////////////////////
/// HSRiskDegreeն
//////////////////////////////////////////////////////////////////////////
typedef double HSRiskDegree;

//////////////////////////////////////////////////////////////////////////
/// HSBankIDб
//////////////////////////////////////////////////////////////////////////
typedef char HSBankID[8];

//////////////////////////////////////////////////////////////////////////
/// HSTransferTypeת
//////////////////////////////////////////////////////////////////////////
/// ת͹˾
#define HS_TT_BankToBroker '1'
/// ͹˾ת
#define HS_TT_BrokerToBank '2'
typedef char HSTransferType;

//////////////////////////////////////////////////////////////////////////
/// HSBankName 
//////////////////////////////////////////////////////////////////////////
typedef char HSBankName[64];

//////////////////////////////////////////////////////////////////////////
/// HSTransferSourceת˷    
//////////////////////////////////////////////////////////////////////////
/// ͹˾
#define HS_TSRC_Broker   '0'
/// 
#define HS_TSRC_Bank     '1'
/// 
#define HS_TSRC_Each     '2'
/// 
#define HS_TSRC_Third    '3'
typedef char HSTransferSource;

//////////////////////////////////////////////////////////////////////////
/// HSTransferStatusת״̬    
//////////////////////////////////////////////////////////////////////////    
/// δ
#define HS_TS_NotReported         '0'
/// ѱ
#define HS_TS_Reported            '1'
/// ɹ
#define HS_TS_Success             '2'
/// 
#define HS_TS_Abandoned           '3'
/// 
#define HS_TS_ReportedToBeCancel  '4'
/// 
#define HS_TS_Canceled            '5'
/// 
#define HS_TS_PendingReversal     '7'
/// ѳ
#define HS_TS_Reversal            '8'
/// 
#define HS_TS_ToBeReported        'A'
/// 
#define HS_TS_Reporting           'P'
/// ȷ
#define HS_TS_Confirmed           'Q'
/// ȷ
#define HS_TS_PendingConfirm      'x'
typedef char HSTransferStatus;

//////////////////////////////////////////////////////////////////////////
/// HSBankAccountID˺ű
//////////////////////////////////////////////////////////////////////////
typedef char HSBankAccountID[32];

//////////////////////////////////////////////////////////////////////////
/// HSAccountID˺ 
//////////////////////////////////////////////////////////////////////////
typedef char HSAccountID[19];

//////////////////////////////////////////////////////////////////////////
/// HSUserIDͻ
//////////////////////////////////////////////////////////////////////////
typedef char HSUserID[32];

//////////////////////////////////////////////////////////////////////////
/// HSBillContent˵ 
//////////////////////////////////////////////////////////////////////////
typedef char HSBillContent[2000];


//////////////////////////////////////////////////////////////////////////
/// HSHedgeTypeͶ()/ױ/
//////////////////////////////////////////////////////////////////////////
/// Ͷ()
#define HS_HT_Speculation       '0'
/// ױ
#define HS_HT_Hedge             '1'
/// 
#define HS_HT_Arbitrage         '2'
/// 
#define HS_HT_MarketMaker       '3'
/// 
#define HS_HT_Covered           '4'
typedef char HSHedgeType;

//////////////////////////////////////////////////////////////////////////
/// HSRate
//////////////////////////////////////////////////////////////////////////
typedef double HSRate;

//////////////////////////////////////////////////////////////////////////
/// HSSessionIDỰ
//////////////////////////////////////////////////////////////////////////
typedef int32 HSSessionID;

//////////////////////////////////////////////////////////////////////////
/// HSUserStationInfoûվϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSUserStationInfo[256];

//////////////////////////////////////////////////////////////////////////
/// HSOrderSysID
//////////////////////////////////////////////////////////////////////////
typedef char HSOrderSysID[32];

//////////////////////////////////////////////////////////////////////////
/// HSCombPositionIDϳֱֲ
//////////////////////////////////////////////////////////////////////////
typedef char HSCombPositionID[33];

//////////////////////////////////////////////////////////////////////////
/// HSPassword
//////////////////////////////////////////////////////////////////////////
typedef char HSPassword[16];

//////////////////////////////////////////////////////////////////////////
/// HSMacAddressMacַ
//////////////////////////////////////////////////////////////////////////
typedef char HSMacAddress[32];

//////////////////////////////////////////////////////////////////////////
/// HSIPAddressIPַ
//////////////////////////////////////////////////////////////////////////
typedef char HSIPAddress[64];

//////////////////////////////////////////////////////////////////////////
/// HSBillConfirmFlagǷҪȷʵı־
//////////////////////////////////////////////////////////////////////////
/// Ҫȷ
#define HS_BCF_NO  '0'
/// Ҫȷ
#define HS_BCF_YES '1'
typedef char HSBillConfirmFlag;

//////////////////////////////////////////////////////////////////////////
/// HSBillConfirmStatus˵ȷ״̬
//////////////////////////////////////////////////////////////////////////
/// δȷ
#define HS_BCFD_NO  '0'
/// ȷ
#define HS_BCFD_YES '1'
typedef char HSBillConfirmStatus;

//////////////////////////////////////////////////////////////////////////
/// HSDeltaʵ
//////////////////////////////////////////////////////////////////////////
typedef double HSDelta;

//////////////////////////////////////////////////////////////////////////
/// HSInstrumentTradeStatusԼ״̬
//////////////////////////////////////////////////////////////////////////
/// (ǰ)
#define HS_IT_Init               'S'
/// Ͼ
#define HS_IT_CallAuction        'C'
/// 
#define HS_IT_Trinding           'T'
/// 
#define HS_IT_Pause              'B'
/// 
#define HS_IT_Close              'E'
/// ̼Ͼ
#define HS_IT_ClosingCallAuction 'U'
/// ж
#define HS_IT_Fusing             'V'
/// ʱͣ
#define HS_IT_Halt               'P'
/// ȫͣ
#define HS_IT_HaltAllDay         '1'
/// ۶(мϾ)
#define HS_IT_FuseToCallAuction  'M'
/// ۶(ͣ)
#define HS_IT_FuseToClose        'N'
/// ̺
#define HS_IT_AfterCloseTrade    'A'
typedef char HSInstrumentTradeStatus;

//////////////////////////////////////////////////////////////////////////
/// HSOpenRestrictionԼʵʱ
//////////////////////////////////////////////////////////////////////////
/// ƿ
#define HS_OR_NoLimitOpen                '0'
/// Ʊҿ
#define HS_OR_LimitCoveredOpen           '1'
/// 
#define HS_OR_LimitSellOpen              '2'
/// ֡ҿ
#define HS_OR_LimitSellAndCovOpen        '3'
/// 뿪
#define HS_OR_LimitBidOpen               '4'
/// 뿪֡ҿ
#define HS_OR_LimitBidAndCovOpen         '5'
/// 뿪֡
#define HS_OR_LimitBidAndSellOpen        '6'
/// 뿪֡ҿ֡
#define HS_OR_LimitBidAndSellAndCovOpen  '7'
typedef char HSOpenRestriction[64];

//////////////////////////////////////////////////////////////////////////
/// HSProductIDԼƷ
//////////////////////////////////////////////////////////////////////////
typedef char HSProductID[5];

//////////////////////////////////////////////////////////////////////////
/// HSMaxMarginSideAlgorithm֤߱㷨
//////////////////////////////////////////////////////////////////////////
/// ʹô֤߱㷨
#define HS_MMSA_NO  '0'
/// ʹô֤߱㷨
#define HS_MMSA_YES '1'
typedef char HSMaxMarginSideAlgorithm;

//////////////////////////////////////////////////////////////////////////
/// HSUserNameͻ
//////////////////////////////////////////////////////////////////////////
typedef char HSUserName[32];

//////////////////////////////////////////////////////////////////////////
/// HSForceCloseReasonǿƽԭ
//////////////////////////////////////////////////////////////////////////
/// ǿƽ
#define HS_FCR_NotForceClose '0'
/// ʽ
#define HS_FCR_LackDeposit '1'
/// ͻ
#define HS_FCR_ClientOverPositionLimit '2'
/// Ա
#define HS_FCR_MemberOverPositionLimit '3'
/// ֲַ
#define HS_FCR_NotMultiple '4'
/// Υ
#define HS_FCR_Violation '5'
/// 
#define HS_FCR_Other '6'
typedef char HSForceCloseReason;

//////////////////////////////////////////////////////////////////////////
/// HSTradingFlag걨־
//////////////////////////////////////////////////////////////////////////
/// ֹ걨
#define HS_TF_No  '0'
/// 걨
#define HS_TF_Yes '1'
typedef char HSTradingFlag;

//////////////////////////////////////////////////////////////////////////
/// HSSwapOrderFlag־
//////////////////////////////////////////////////////////////////////////
/// ǻ
#define HS_SOF_Normal            '0'
/// 
#define HS_SOF_Swap              '1'
typedef char HSSwapOrderFlag;

//////////////////////////////////////////////////////////////////////////
/// HSPasswordType
//////////////////////////////////////////////////////////////////////////
/// ʽ
#define HS_PWDT_Fund             '1'
/// 
#define HS_PWDT_Trade            '2'
typedef char HSPasswordType;

//////////////////////////////////////////////////////////////////////////
/// HSOrderCommandָ
//////////////////////////////////////////////////////////////////////////
/// ޼ 
#define HS_CT_Limit                                 1
/// ޼ۼʱȫɽ 
#define HS_CT_LimitFOK                              2
/// ޼ʱɽʣ೷ 
#define HS_CT_LimitFAK                              3
/// ޼ֹ 
#define HS_CT_LimitStopLoss                         4
/// ޼ֹӯ 
#define HS_CT_LimitStopProfit                       5
/// м 
#define HS_CT_Market                                6
/// мۼʱȫɽ 
#define HS_CT_MarketFOK                             7
/// мʱɽʣ೷ 
#define HS_CT_MarketFAK                             8
/// мָɽʱɽʣ೷ 
#define HS_CT_MarketFAKV                            9
/// мֹ 
#define HS_CT_MarketStopLoss                        10
/// мֹӯ 
#define HS_CT_MarketStopProfit                      11
/// мۼʱɽʣת޼ 
#define HS_CT_MarketToLimit                         12
/// 嵵мۼʱɽʣ೷ 
#define HS_CT_Market5FAK                            13
/// 嵵мۼʱɽʣת޼ 
#define HS_CT_Market5ToLimit                        14
/// żۼʱɽʣת޼ 
#define HS_CT_Market1ToLimit                        15
/// żۼʱɽʣ೷ 
#define HS_CT_Market1FAK                            16
/// żۼʱȫɽ 
#define HS_CT_Market1FOK                            17
/// żת޼
#define HS_CT_MarketSelfToLimit                     18
/// ַż걨
#define HS_CT_CounterPartyBest		                19
/// ޼ָʱɽʣ೷
#define HS_CT_LimitFAKV                             20
/// ̶̺۸
#define HS_CT_LimitPFP                              21
/// ۹ͨЧ޼
#define HS_CT_HkAtCrossingLimitGFD 					22
/// ۹ͨʱȫɽ޼
#define HS_CT_HkAtCrossingLimitFOK 					23
/// ۹ͨǿ޼
#define HS_CT_HkDayLimit 							24
/// ۽TAS
#define HS_CT_TAS									25
/// ֲױȷ 
#define HS_CT_HoldHedgeConfirm                      26
/// ȷ
#define HS_CT_SpreadArbitrageConfirm                27
/// ڽ׶ί
#define HS_CT_BlockPricing                          28
/// ڽȷί
#define HS_CT_BlockConfirm                          29
/// ڽ׻ȷί
#define HS_CT_BlockMutualConfirm                    30
/// ڽ̺̼ί
#define HS_CT_BlockAFC                              31
/// ڽ̺Ȩƽί
#define HS_CT_BlockAFW                              32
/// ڽί
#define HS_CT_BlockIntention                        33
/// ֤ת޼
#define HS_CT_BJSGZLimit							34
/// ޼СЧ
#define HS_CT_LimitGIS                              35
/// ޼ֹСЧ
#define HS_CT_LimitStopLossGIS                      36
/// ޼ֹӯСЧ
#define HS_CT_LimitStopProfitGIS                    37
/// мСЧ
#define HS_CT_MarketGIS                             38
/// мֹСЧ
#define HS_CT_MarketStopLossGIS                     39
/// мֹӯСЧ
#define HS_CT_MarketStopProfitGIS                   40
typedef int32 HSOrderCommand;

//////////////////////////////////////////////////////////////////////////
/// HSNum 
//////////////////////////////////////////////////////////////////////////
typedef int32 HSNum;

//////////////////////////////////////////////////////////////////////////
/// HSBrokerOrderID͹˾ 
//////////////////////////////////////////////////////////////////////////
typedef char HSBrokerOrderID[32];

//////////////////////////////////////////////////////////////////////////
/// HSBusinessNameҵ
//////////////////////////////////////////////////////////////////////////
typedef char HSBusinessName[65];

//////////////////////////////////////////////////////////////////////////
/// HSUserApplicationTypeͶ߶Ӧ
//////////////////////////////////////////////////////////////////////////
typedef char HSUserApplicationType;

//////////////////////////////////////////////////////////////////////////
/// HSUserApplicationInfoͶ߶ӦϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSUserApplicationInfo[32];

//////////////////////////////////////////////////////////////////////////
/// HSSecurityType:гҵ
//////////////////////////////////////////////////////////////////////////
/// δ֪
#define HS_SET_UnKnown      '0'
/// Ʊ
#define HS_SET_Stock        '1'
/// ָ
#define HS_SET_Index        '2'
/// 
#define HS_SET_Fund         '3'
/// ծȯ
#define HS_SET_Bond         '4'
/// Ȩ
#define HS_SET_Option       '5'
/// ETFȨ
#define HS_SET_ETFOption    '6'
/// ڻ
#define HS_SET_FUTU         '7'
/// ڻȨ
#define HS_SET_FUTUOption   '8'
typedef char HSSecurityType;

//////////////////////////////////////////////////////////////////////////
/// HSSubSecurityType:гҵϸ
//////////////////////////////////////////////////////////////////////////
/// δ֪
#define HS_SSET_UnKnown             "M"
/// ָ
#define HS_SSET_Index               "MRI"
/// A
#define HS_SSET_S_A                 "ESA.M"
/// B
#define HS_SSET_S_B                 "ESA.B"
/// ƴ
#define HS_SSET_S_Star              "KSH"
/// ҵ
#define HS_SSET_S_Gem               "GEM"
/// ȹ
#define HS_SSET_S_Prefer            "ER"
/// Ʊ
#define HS_SSET_S_OtherStock        "S"
/// ת
#define HS_SSET_S_ZSZR              "ZSZR"
/// ת 
#define HS_SSET_S_JJZR              "JJZR"
/// 
#define HS_SSET_S_LWTS              "LWTS"   
/// ()
#define HS_SSET_S_LXJJ              "LXJJ"
/// ת
#define HS_SSET_S_QTZR              "QTZR"
/// Ϳʽָ(ETF)
#define HS_SSET_F_ETF               "EM.ETF"
/// пŻ(LOF)
#define HS_SSET_F_LOF               "EM.LOF"
/// ʽ
#define HS_SSET_F_CEF               "EM.CEF"
/// ּ
#define HS_SSET_F_SF                "EM.SF"
/// ʽ
#define HS_SSET_F_OEF               "EM.OEF"
/// Ͷл(REITs)
#define HS_SSET_F_REITs             "CB.RET"
/// 
#define HS_SSET_F_OtherFund         "F"
/// ծ
#define HS_SSET_D_GBF               "D.GBF"
/// ҵծ
#define HS_SSET_D_CBF               "D.CBF"
/// ˾ծ
#define HS_SSET_D_CPF               "D.CPF"
/// תծ
#define HS_SSET_D_CCF               "D.CCF"
/// ծȯع
#define HS_SSET_D_REPO              "D.REPO"
/// ծȯԤ
#define HS_SSET_D_WIT               "D.WIT"
/// ծȯ
#define HS_SSET_D_OtherBond         "D"
typedef char HSSubSecurityType[16];

//////////////////////////////////////////////////////////////////////////
/// HSMarketBizType:ҵ
//////////////////////////////////////////////////////////////////////////
/// δ֪
#define HS_MBT_UnKnown      '0'
/// ֻ
#define HS_MBT_Stock        '1'
/// Ȩ
#define HS_MBT_Option       '2'
/// ڻ
#define HS_MBT_Future       '3'
typedef char HSMarketBizType;

//////////////////////////////////////////////////////////////////////////
/// HSOrdType:ί
//////////////////////////////////////////////////////////////////////////
/// м 
#define HS_ORT_Market         '1'
/// ޼ 
#define HS_ORT_Limit          '2'
/// 
#define HS_ORT_MarketSelf     'U'
/// ίж
#define HS_ORT_Add            'A'
/// ɾίж 
#define HS_ORT_Delete         'D'
/// Ʒ״̬ 
#define HS_ORT_Status         'S'
typedef char HSOrdType;

//////////////////////////////////////////////////////////////////////////
/// HSTrdType:ɽ
//////////////////////////////////////////////////////////////////////////
///  
#define HS_TRD_Inside      'S'
///  
#define HS_TRD_Outside     'B'
/// δ֪
#define HS_TRD_UnKnown     'N'
/// 
#define HS_TRD_Cancel      '4'
/// ͨɽ
#define HS_TRD_Execute     'F'
typedef char HSTrdType;

//////////////////////////////////////////////////////////////////////////
/// HSTransType:
//////////////////////////////////////////////////////////////////////////
/// ʳɽί
#define HS_TRANS_All      '0'
/// ʳɽ
#define HS_TRANS_Trade    '1'
/// ί
#define HS_TRANS_Entrust  '2'
typedef char HSTransType;

//////////////////////////////////////////////////////////////////////////
/// HSTransFlag:ݱʶ
//////////////////////////////////////////////////////////////////////////
/// δ֪ʶ
#define HS_TRF_UnKnown   0
/// ʳɽίŶ
#define HS_TRF_Alone     1
/// ʳɽίͳһ
#define HS_TRF_Unified   2
typedef int32 HSTransFlag;

//////////////////////////////////////////////////////////////////////////
/// HSInstrumentEngNameԼӢ
//////////////////////////////////////////////////////////////////////////
typedef char HSInstrumentEngName[64];

//////////////////////////////////////////////////////////////////////////
/// HSProductTypeƷ
//////////////////////////////////////////////////////////////////////////
/// ڻ
#define HS_PTYPE_Futures             '1'
/// ڻȨ
#define HS_PTYPE_OptFutu             '2'
/// 
#define HS_PTYPE_Combination         '3'
/// 
#define HS_PTYPE_Spot                '4'
/// ת
#define HS_PTYPE_FutuToSpot          '5'
/// ֤ȯ
#define HS_PTYPE_Securities          '6'
/// ƱȨ
#define HS_PTYPE_OptStock            '7'
/// TASԼ
#define HS_PTYPE_TAS                 '8'
typedef char HSProductType;

//////////////////////////////////////////////////////////////////////////
/// HSCurrencyID
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_CID_CNY                   '0'
/// Ԫ
#define HS_CID_USD                   '1'
/// ۱
#define HS_CID_HKD                   '2'
typedef char HSCurrencyID;

//////////////////////////////////////////////////////////////////////////
/// HSCloseFlagȨȨɵͷǷԶƽֱ־
//////////////////////////////////////////////////////////////////////////
/// Զƽ
#define HS_CF_NO                    '0'
/// Զƽ
#define HS_CF_YES                   '1'
typedef char HSCloseFlag;

//////////////////////////////////////////////////////////////////////////
/// HSCombType
//////////////////////////////////////////////////////////////////////////
/// ͨ
#define HS_COMBT_PT                 '0'
/// 
#define HS_COMBT_KQ                 '1'
/// Ʒ
#define HS_COMBT_KPZ                '2'
typedef char HSCombType;

//////////////////////////////////////////////////////////////////////////
/// HSRiskLevelյȼ
//////////////////////////////////////////////////////////////////////////
/// Ĭ
#define HS_RL_Default               "0"
/// 
#define HS_RL_Keep                  "1"
/// 
#define HS_RL_Cautions              "2"
/// Ƚ
#define HS_RL_Steady                "3"
/// 
#define HS_RL_Active                "4"
/// ɳ
#define HS_RL_Growth                "6"
/// רҵͶ
#define HS_RL_Profession            "99"
/// Զյȼ
#define HS_RL_Diy                   "100"
typedef char HSRiskLevel[4];

//////////////////////////////////////////////////////////////////////////
/// HSAppIDTypeͻID
//////////////////////////////////////////////////////////////////////////
/// ֱͶ
#define HS_AT_Investor					 '1'
/// Ͷ߹һԱӵм
#define HS_AT_OperatorRelay				 '2'
/// ΪÿͶ߶ӵм
#define HS_AT_InvestorRelay              '3'
/// δ֪
#define HS_AT_UnKnown				     '0'
typedef char HSAppIDType;

//////////////////////////////////////////////////////////////////////////
/// HSAppIDͻID
//////////////////////////////////////////////////////////////////////////
typedef char HSAppID[32];

//////////////////////////////////////////////////////////////////////////
/// HSAuthCode֤
//////////////////////////////////////////////////////////////////////////
typedef char HSAuthCode[128];


//////////////////////////////////////////////////////////////////////////
/// HSAppSysInfoͻϵͳϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSAppSysInfo[2000];

//////////////////////////////////////////////////////////////////////////
/// HSAppSysInfoIntegrityͻϵͳϢɼ
//////////////////////////////////////////////////////////////////////////
typedef char HSAppSysInfoIntegrity[2000];

//////////////////////////////////////////////////////////////////////////
/// HSAppAbnormalTypeͻ˿ͻϵͳϢɼ쳣ʶ
//////////////////////////////////////////////////////////////////////////
typedef char HSAppAbnormalType;

//////////////////////////////////////////////////////////////////////////
/// HSTradeTypeɽ
//////////////////////////////////////////////////////////////////////////
/// ͨɽϲ
#define HS_TT_Common                '0'
/// Ȩִ
#define HS_TT_OptionsExecution      '1'
/// OTCɽ
#define HS_TT_OTC                   '2'
/// תɽ
#define HS_TT_EFPDerived            '3'
/// ɽ
#define HS_TT_CombinationDerived    '4'
typedef char HSTradeType;

//////////////////////////////////////////////////////////////////////////
/// HSTransDirection
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_TD_In                    '0'
/// ӽĵ
#define HS_TD_Out                   '1'
typedef char HSTransDirection;

//////////////////////////////////////////////////////////////////////////
/// HSExchangeRate
//////////////////////////////////////////////////////////////////////////
typedef double HSExchangeRate;

//////////////////////////////////////////////////////////////////////////
/// HSOccasion
//////////////////////////////////////////////////////////////////////////
typedef char HSOccasion[32];

//////////////////////////////////////////////////////////////////////////
/// رģʽ
//////////////////////////////////////////////////////////////////////
enum SUB_TERT_TYPE
{
	///ӱտʼش
	HS_TERT_RESTART = 0,
	///ϴյ
	HS_TERT_RESUME,
	///ӵ¼µĿʼ
	HS_TERT_QUICK,
    ///ָſʼ
    HS_TERT_DESIGNATED,
	///Ϣ
	HS_TERT_REFUSE
};

//////////////////////////////////////////////////////////////////////////
/// HSStatus:״̬
//////////////////////////////////////////////////////////////////////////
typedef char HSStatus;

//////////////////////////////////////////////////////////////////////////
/// HSType:
//////////////////////////////////////////////////////////////////////////
typedef char HSType;

//////////////////////////////////////////////////////////////////////////
/// HSFlag:־
//////////////////////////////////////////////////////////////////////////
typedef char HSFlag;

//////////////////////////////////////////////////////////////////////////
/// HSRisk:
//////////////////////////////////////////////////////////////////////////
typedef double HSRisk;               

//////////////////////////////////////////////////////////////////////////
/// HSStockType:֤ȯ
//////////////////////////////////////////////////////////////////////////
/// Ʊ
#define HS_ST_Stock       "0"
/// 
#define HS_ST_Fund        "1"
/// Ȩ֤
#define HS_ST_MarthSecu   "3"
/// ͨ깺
#define HS_ST_Apply       "4"
/// ˹ծ
#define HS_ST_RegDebt     "9"
/// 
#define HS_ST_FundAppRed  "A"
/// LOF
#define HS_ST_LofFund     "L"
/// ETF
#define HS_ST_EtfFund     "T"
/// ETF
#define HS_ST_EtfAppRed   "N"
/// ҵ
#define HS_ST_Gem         "c"
/// ƴƱ
#define HS_ST_Star        "e"
/// ƴƾ֤
#define HS_ST_StarCdr     "g"
/// עƴҵ
#define HS_ST_RegGem      "p"
/// עƴҵƾ֤
#define HS_ST_RegGemCdr   "q"
typedef char HSStockType[5];               

//////////////////////////////////////////////////////////////////////////
/// HSSubStockType:֤ȯ
//////////////////////////////////////////////////////////////////////////
/// ȹ
#define HS_SST_PublicPreferStock       "01"
/// ǹȹ
#define HS_SST_NonPublicPreferStock    "02"
/// ¹ֵ깺
#define HS_SST_MarketValueApply		   "41"
/// ծȯ깺
#define HS_SST_BondCreditApply		   "G1"
typedef char HSSubStockType[5];

//////////////////////////////////////////////////////////////////////////
/// HSStockCode:֤ȯ
//////////////////////////////////////////////////////////////////////////
typedef char HSStockCode[7];               

//////////////////////////////////////////////////////////////////////////
/// HSStockAccount:֤ȯ˻
//////////////////////////////////////////////////////////////////////////
typedef char HSStockAccount[21];           

//////////////////////////////////////////////////////////////////////////
/// HSStockName:֤ȯ
//////////////////////////////////////////////////////////////////////////
typedef char HSStockName[33];              

//////////////////////////////////////////////////////////////////////////
/// HSCompactID:Լ
//////////////////////////////////////////////////////////////////////////
typedef char HSCompactID[33];              

//////////////////////////////////////////////////////////////////////////
/// HSCashGroupProp:ͷ
//////////////////////////////////////////////////////////////////////////
/// ͨͷ
#define HS_CGP_Common       '1'
/// רͷ
#define HS_CGP_Special      '2'
typedef char HSCashGroupProp;

//////////////////////////////////////////////////////////////////////////
/// HSTradeStatusɽ״̬
//////////////////////////////////////////////////////////////////////////
/// ɽ
#define HS_TDS_Traded           '0'
/// ϵ
#define HS_TDS_Abandoned        '2'
/// ȷ
#define HS_TDS_Confirmed        '4'
typedef char HSTradeStatus;

//////////////////////////////////////////////////////////////////////////
/// HSEtfStatus깺״̬
//////////////////////////////////////////////////////////////////////////
/// ȫֹ
#define HS_ES_BothForbid       '0'
/// ȫ
#define HS_ES_BothAllow        '1'
/// ֻ깺
#define HS_ES_OnlyPurchase     '2'
/// ֻ
#define HS_ES_OnlyRedeem       '3'
typedef char HSEtfStatus;

//////////////////////////////////////////////////////////////////////////
/// HSEtfTypeEtf
//////////////////////////////////////////////////////////////////////////
/// ETF
#define HS_ET_SingelExchEtf       '1'
/// 羳ETF
#define HS_ET_CrossBorderEtf      '2'
/// ETF
#define HS_ET_CrossExchEtf        '3'
/// ETF
#define HS_ET_CurrencyEtf         '4'
/// ʵծȯETF
#define HS_ET_PhysicalBondEtf     '5'
/// ƷETF
#define HS_ET_CommodityEtf        '6'
/// ֽծȯETF
#define HS_ET_CashBondEtf         '7'
typedef char HSEtfType;

//////////////////////////////////////////////////////////////////////////
/// HSCollateralStatus״̬
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_COS_Normal             '0'
/// ͣ
#define HS_COS_Pause              '1'
/// 
#define HS_COS_Cancel             '2'
typedef char HSCollateralStatus;

//////////////////////////////////////////////////////////////////////////
/// HSCreditRateType
//////////////////////////////////////////////////////////////////////////
/// ͨ
#define HS_CRT_MarginBuy	      '1'
/// ͨȯ
#define HS_CRT_ShortSell          '2'
/// ͨʷϢ
#define HS_CRT_MarginBuyFine      '3'
/// ͨȯϢ
#define HS_CRT_ShortSellFine      '4'
/// ר
#define HS_CRT_SpeMarginBuy	      '5'
/// רȯ
#define HS_CRT_SpeShortSell       '6'
/// רʷϢ
#define HS_CRT_SpeMarginBuyFine   '7'
/// רȯϢ
#define HS_CRT_SpeShortSellFine   '8'
typedef char HSCreditRateType;

//////////////////////////////////////////////////////////////////////////
/// HSCompactTypeԼ
//////////////////////////////////////////////////////////////////////////
/// ʺԼ
#define HS_COT_MarginBuy	      '0'
/// ȯԼ
#define HS_COT_ShortSell          '1'
/// ծ
#define HS_COT_OtherDebit         '2'
typedef char HSCompactType;

//////////////////////////////////////////////////////////////////////////
/// HSCompactSourceԼԴ
//////////////////////////////////////////////////////////////////////////
/// ͨͷ
#define HS_COS_Public	        '0'
/// רͷ
#define HS_COS_Special          '1'
typedef char HSCompactSource;

//////////////////////////////////////////////////////////////////////////
/// HSOrderPartition
//////////////////////////////////////////////////////////////////////////
/// ͨ
#define HS_OP_Secu				1
/// ̺ͨ
#define HS_OP_SecuAfof          2
/// ͨۺϣ֤ȯҵ̶̺۸ҵıǸֵ
#define HS_OP_SecuCbp           3
/// ۹ͨ
#define HS_OP_SecuHk            4
/// þ
#define HS_OP_Crdt              5
/// ̺
#define HS_OP_CrdtAfof          6
/// ۺϣȯҵ̶̺۸ҵıǸֵ
#define HS_OP_CrdtCbp           7
/// ͨ
#define HS_OP_SecuBt            8
typedef int32 HSOrderPartition;

//////////////////////////////////////////////////////////////////////////
/// HSAssetPropʲ
//////////////////////////////////////////////////////////////////////////
typedef char HSAssetProp;

//////////////////////////////////////////////////////////////////////////
/// HSSessionNoỰ
//////////////////////////////////////////////////////////////////////////
typedef int32 HSSessionNo;

//////////////////////////////////////////////////////////////////////////
/// HSSysnodeIDϵͳڵ
//////////////////////////////////////////////////////////////////////////
typedef int32 HSSysnodeID;

//////////////////////////////////////////////////////////////////////////
/// HSBatchNoκ
//////////////////////////////////////////////////////////////////////////
typedef int32 HSBatchNo;

//////////////////////////////////////////////////////////////////////////
/// HSOrderID걨 
//////////////////////////////////////////////////////////////////////////
typedef char HSOrderID[11];

//////////////////////////////////////////////////////////////////////////
/// HSCompactIDStrԼŴ
//////////////////////////////////////////////////////////////////////////
typedef char HSCompactIDStr[2001];

//////////////////////////////////////////////////////////////////////////
/// HSDelistFlagб־
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_DF_Normal				'0'
/// 
#define HS_DF_Delist				'1'
typedef char HSDelistFlag;

//////////////////////////////////////////////////////////////////////////
/// HSChannelTypeͨ
//////////////////////////////////////////////////////////////////////////
/// ޹
#define HS_CNT_Normal			'0'
/// 
#define HS_CNT_Of				'1'
/// ̺
#define HS_CNT_Afof				'2'
typedef char HSChannelType;

//////////////////////////////////////////////////////////////////////////
/// HSRealActionTypeױ䶯
//////////////////////////////////////////////////////////////////////////
/// ܵ
#define HS_RA_TodayAdjustment	'0'
/// ׶
#define HS_RA_Frozen			'1'
/// رⶳ
#define HS_RA_Unfrozen			'2'
/// 
#define HS_RA_Deposit			'D'
/// 
#define HS_RA_Withdrawal		'W'
/// 
#define HS_RA_Lock				'L'
/// 
#define HS_RA_Unlock			'U'
typedef char HSRealActionType;

//////////////////////////////////////////////////////////////////////////
/// HSBusinessFlagҵ־
//////////////////////////////////////////////////////////////////////////
/// ͻʽ
#define HS_BF_FundTrans	        2034
/// ͻɷݵ
#define HS_BF_StockTrans	    3005
/// ͻETFֲֵ
#define HS_BF_EtfStockTrans		3006
/// 
#define HS_BF_FinBuy			31000
/// ȯ
#define HS_BF_SellRepay		    31011
/// Զʸծ黹
#define HS_BF_AutoFinRepay		31014
/// Զʷ֧
#define HS_BF_PayOff_CashRepay	31016
/// ƽ
#define HS_BF_PayOff_FinRepay	31017
/// ȯ
#define HS_BF_SloSell			31100
/// ȯȯ
#define HS_BF_BuyRepay			31101
/// ƽȯȯ
#define HS_BF_PayOff_BuyRepay	31102
/// ֱӻȯ
#define HS_BF_HoldRepay			31103
/// ƽȯȯ
#define HS_BF_PayOff_HoldRepay	31104
/// ȯֽ˽
#define HS_BF_SloCashRepay	    31107
/// ȯԼչ״̬
#define HS_BF_CompactApply	    31118
typedef int32 HSBusinessFlag;

/////////////////////////////////////////////////////////////////////////
/// HSOrderAssStatus״̬
/////////////////////////////////////////////////////////////////////////
/// ¼
#define HS_OCR_OrderInserted 		 '0'
/// 걨
#define HS_OCR_OrderReported 		 '1'
/// ѱȷ
#define HS_OCR_OrderConfirmed 		 '2'
/// ϳɽ
#define HS_OCR_OrderTraded			 '3'
/// ϵ
#define HS_OCR_OrderAbandoned 		 '4'
/// ¼
#define HS_OCR_CancelInserted 		 '5' 
/// 걨
#define HS_OCR_CancelReported		 '6'
/// ѱȷ
#define HS_OCR_CancelConfirmed		 '7'
/// ϵ
#define HS_OCR_CancelFailed 		 '8'
typedef char HSOrderAssStatus;

/////////////////////////////////////////////////////////////////////////
/// HSStockPropertyɷ
/////////////////////////////////////////////////////////////////////////
/// ͨ
#define HS_SP_Unlimited				"00"
/// IPO۹
#define HS_SP_Limited				"01"
typedef char HSStockProperty[3];

//////////////////////////////////////////////////////////////////////////
/// HSMsgBodyϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSMsgBody[4000];

//////////////////////////////////////////////////////////////////////////
/// HSMsgTitleϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSMsgTitle[256];

//////////////////////////////////////////////////////////////////////////
/// HSMsgTypeϢ
//////////////////////////////////////////////////////////////////////////
typedef char HSMsgType;

//////////////////////////////////////////////////////////////////////////
/// HSStrTimeʱ䣨ַʽ
//////////////////////////////////////////////////////////////////////////
typedef char HSStrTime[32];

//////////////////////////////////////////////////////////////////////////
/// HSTopOrderType
//////////////////////////////////////////////////////////////////////////
/// ִжҵ
#define HS_TOT_UnTopOrder           '0'
/// һί
#define HS_TOT_LastOrder            '1'
/// ָί
#define HS_TOT_SpecifiedOrder       '2'
typedef char HSTopOrderType;

//////////////////////////////////////////////////////////////////////////
/// HSExchangeStatus״̬
//////////////////////////////////////////////////////////////////////////
/// ӶϿ
#define HS_EXS_DisConnect			'0'
/// ǰ
#define HS_EXS_BeforeOpening		'1'
/// Ͼ걨
#define HS_EXS_AuctionOrder			'2'
/// Ͼƽ
#define HS_EXS_AuctionBalance		'3'
/// Ͼ۴
#define HS_EXS_AuctionMatch			'4'
/// 
#define HS_EXS_Trade				'5'
/// ͣ
#define HS_EXS_TradePause			'6'
/// ױ
#define HS_EXS_TradeClose			'7'
/// δ֪״̬
#define HS_EXS_Unknown				'X'
typedef char HSExchangeStatus;

//////////////////////////////////////////////////////////////////////////
/// HSClientOrderIDͻ˱
////////////////////////////////////////////////////////////////////////// 
typedef int64 HSClientOrderID;

//////////////////////////////////////////////////////////////////////////
/// HSCompactStatus:Լ״̬
//////////////////////////////////////////////////////////////////////////
//δ黹
#define   HS_CS_OpenNoret                      '0'  
//ֹ黹
#define   HS_CS_PartRet                        '1' 
//Լѹ
#define   HS_CS_Overload                       '2'   
//ͻй黹
#define   HS_CS_CustEnd                        '3'   
//ֹ˽
#define   HS_CS_ManEnd                         '4'    
//δγɸծ
#define   HS_CS_NoDebit                        '5'    
typedef char HSCompactStatus;

//////////////////////////////////////////////////////////////////////////
/// HSExchangeAccountIDױ
//////////////////////////////////////////////////////////////////////////
typedef char HSExchangeAccountID[32];

//////////////////////////////////////////////////////////////////////////
/// HSCombStrategyTypeϲ
//////////////////////////////////////////////////////////////////////////
/// 
#define HS_CST_NoReport 			'0'
/// 
#define HS_CST_Arbitrage			'1'
/// ϶
#define HS_CST_Comb					'2'
/// 
#define HS_CST_Batch				'3'
/// Ȩִ붨
#define HS_CST_OptExec				'4'
/// ˫߱۶
#define HS_CST_Quote				'5'
/// 
#define HS_CST_Swap					'6'
/// 
#define HS_CST_ArbiSP				'7'
/// Ʒ
#define HS_CST_ArbiSPC				'8'
/// ȨֱȨ
#define HS_CST_FOptBUL				'9'
/// ȨֱȨ
#define HS_CST_FOptBER				'A'
/// ȨˮƽȨ
#define HS_CST_FOptBLT				'B'
/// ȨˮƽȨ
#define HS_CST_FOptBRT				'C'
/// Ȩʽ
#define HS_CST_FOptSTD				'D'
/// Ȩʽ
#define HS_CST_FOptSTG				'E'
/// ȨתCNV
#define HS_CST_CNV					'F'
/// ȨڿSPZ
#define HS_CST_SPZ					'G'
/// ȨڻPRT
#define HS_CST_PRT					'H'
/// ͬԼ
#define HS_CST_Lock					'I'
/// Ȩ۲
#define HS_CST_FOptCAS				'J'
/// ڻȨ
#define HS_CST_FOptBFO				'K'
/// ڻȨ
#define HS_CST_FOptSFO				'L'
typedef char HSCombStrategyType;

//////////////////////////////////////////////////////////////////////////
/// HSSysnodeNameϵͳڵ
//////////////////////////////////////////////////////////////////////////
typedef char HSSysnodeName[64];

//////////////////////////////////////////////////////////////////////////
/// HSQueryTypeѯ
//////////////////////////////////////////////////////////////////////////
/// ѯȫί
#define HS_QT_All					'0'
/// ѯɳί
#define HS_QT_Cancel				'1'
typedef char HSQueryType;

//////////////////////////////////////////////////////////////////////////
/// HSCheckVersionAPIṹ汾У
//////////////////////////////////////////////////////////////////////////
typedef int32 HSCheckVersion;

//////////////////////////////////////////////////////////////////////////
/// HSLicenseFile֤ļ
//////////////////////////////////////////////////////////////////////////
typedef char HSLicenseFile[255];

//////////////////////////////////////////////////////////////////////////
/// HSLicensePassward֤
//////////////////////////////////////////////////////////////////////////
typedef char HSLicensePassward[32];

//////////////////////////////////////////////////////////////////////////
/// HSSafeLevelȫ
//////////////////////////////////////////////////////////////////////////
/// ޼
#define HS_SL_None					"none"
/// ͨѶ֤
#define HS_SL_Pwd					"pwd"
/// SSL
#define HS_SL_SSL					"ssl"
typedef char HSSafeLevel[32];

//////////////////////////////////////////////////////////////////////////
/// HSHkszBusiness۹ɷǽҵ
////////////////////////////////////////////////////////////////////////// 
/// Ϲ걨
#define HS_HKSZBS_PGRG "PGRG"
/// ѡȨ걨
#define HS_HKSZBS_QPSB "QPSB"
/// չ걨
#define HS_HKSZBS_SGBG "SGBG"
/// ͶƱ걨
#define HS_HKSZBS_TPSB "TPSB"
typedef char HSHkszBusiness[5];

//////////////////////////////////////////////////////////////////////////
/// HSCorbehaviorCode˾Ϊ
////////////////////////////////////////////////////////////////////////// 
typedef char HSCorbehaviorCode[17];

//////////////////////////////////////////////////////////////////////////
/// HSPlacardId
////////////////////////////////////////////////////////////////////////// 
typedef char HSPlacardId[21];

//////////////////////////////////////////////////////////////////////////
/// HSMotionId鰸
////////////////////////////////////////////////////////////////////////// 
typedef char HSMotionId[21];

//////////////////////////////////////////////////////////////////////////
/// HSAllotNo
////////////////////////////////////////////////////////////////////////// 
typedef char HSAllotNo[25];

//////////////////////////////////////////////////////////////////////////
/// HSCsdcBusiSerialNoеҵˮ
////////////////////////////////////////////////////////////////////////// 
typedef char HSCsdcBusiSerialNo[17];

//////////////////////////////////////////////////////////////////////////
/// HSInfoKind֪ͨϢ
////////////////////////////////////////////////////////////////////////// 
/// H01-۹ͨȨǼ֪ͨϢ
#define HS_IK_H01 "H01"
/// H05-۹ͨұ֪ͨϢ
#define HS_IK_H05 "H05"
/// H06-۹ͨͶƱ֪ͨϢ
#define HS_IK_H06 "H06"
/// H07-۹ֽͨչ֪ͨϢ
#define HS_IK_H07 "H07"
/// H08-۹ͨɷչ֪ͨϢ
#define HS_IK_H08 "H08"
/// H09-۹ֽͨ͹ɷչ֪ͨϢ
#define HS_IK_H09 "H09"
/// H10-ɷݷֲϲ֪ͨϢ
#define HS_IK_H10 "H10"
/// H12-۹ͨͶƱ鰸֪ͨϢ
#define HS_IK_H12 "H12"
/// H13-۹֪ͨͨϢ
#define HS_IK_H13 "H13"
/// H14-۹֪ͨͨϢ
#define HS_IK_H14 "H14"
typedef char HSInfoKind[4];

//////////////////////////////////////////////////////////////////////////
/// HSReturnCodeش
////////////////////////////////////////////////////////////////////////// 
typedef char HSReturnCode[9];

//////////////////////////////////////////////////////////////////////////
/// HSReturnInfoϢ
////////////////////////////////////////////////////////////////////////// 
typedef char HSReturnInfo[256];

//////////////////////////////////////////////////////////////////////////
/// HSBusinessTypeҵ
////////////////////////////////////////////////////////////////////////// 
/// '1'-֤ȯ, Ӧ۹ɷǽ걨ҵ:Ϲ-'PGRG'
#define HS_BT_ZQPG '1'
/// '6'-Ϣ, Ӧ۹ɷǽ걨ҵ:Ϣ-'QPSB'
#define HS_BT_GXRZ '6'
/// 'U'-չ, Ӧ۹ɷǽ걨ҵ:չ-'SGBG'
#define HS_BT_SGRZ 'U'
/// 'n'-Ȩ, Ӧ۹ɷǽ걨ҵ:ͶƱ걨-'TPSB'
#define HS_BT_QYSJ 'n'
typedef char HSBusinessType;

//////////////////////////////////////////////////////////////////////////
/// HSNoticeNo:ʾ
////////////////////////////////////////////////////////////////////////// 
/// 5-REITs20ۼǵ20%ǵ5%עͶʷ
#define HS_NOTICE_NO_RISK_OVER_LIMIT 5
typedef int32 HSNoticeNo;

//////////////////////////////////////////////////////////////////////////
/// HSSslVersionSSL汾
//////////////////////////////////////////////////////////////////////////
/// SSLV2
#define HS_SV_SSLV2  "SSLV2"
/// SSLV3
#define HS_SV_SSLV3  "SSLV3"
/// SSLV23
#define HS_SV_SSLV23 "SSLV23"
/// TLSV1
#define HS_SV_TLSV1  "TLSV1"
/// 
#define HS_SV_GEER   "gergmssl"
/// Ű͹
#define HS_SV_XASJ   "xasjgmssl"
typedef char HSSslVersion[32];

//////////////////////////////////////////////////////////////////////////
/// HSHktTradeLimit۹ͨ
//////////////////////////////////////////////////////////////////////////
/// δ֪
#define HS_HKT_UNKNOWN            '0'
/// ۹ͨƽ
#define HS_HKT_ORDER_LIMIT        '1'
/// ۹ͨƽ
#define HS_HKT_ORDER_UNLIMIT      '2'
typedef char HSHktTradeLimit;

//////////////////////////////////////////////////////////////////////////
/// HSMemberID̴
//////////////////////////////////////////////////////////////////////////
typedef char	HSMemberID[7];

//////////////////////////////////////////////////////////////////////////
/// HSQuoteIDϢ
//////////////////////////////////////////////////////////////////////////
typedef char	HSQuoteID[11];

//////////////////////////////////////////////////////////////////////////
/// HSInvestorTypeծȯ
//////////////////////////////////////////////////////////////////////////
/// Ӫ
#define HS_INT_ZY		"01"
/// ʹ
#define HS_INT_ZG		"02"
/// 
#define HS_INT_JGJJ		"03"
/// ˾
#define HS_INT_GRJJ		"04"
typedef char	HSInvestorType[3];

//////////////////////////////////////////////////////////////////////////
/// HSInvestorIDծȯ
//////////////////////////////////////////////////////////////////////////
typedef char	HSInvestorID[11];

//////////////////////////////////////////////////////////////////////////
/// HSTraderCodeԱ
//////////////////////////////////////////////////////////////////////////
typedef char	HSTraderCode[11];

//////////////////////////////////////////////////////////////////////////
/// HSSettlPeriod
//////////////////////////////////////////////////////////////////////////
typedef uint16  HSSettlPeriod;

//////////////////////////////////////////////////////////////////////////
/// HSSettlType㷽ʽ
//////////////////////////////////////////////////////////////////////////
/// ߾
#define HS_SETTLTYPE_DBJE    103
/// ȫ
#define HS_SETTLTYPE_ZBQE    104
typedef uint16  HSSettlType;

//////////////////////////////////////////////////////////////////////////
/// HSBondTradeTypeծȯ׷ʽ
//////////////////////////////////////////////////////////////////////////
/// ƥɽ
#define  HS_BTT_PPCJ		  1
/// Э̳ɽ
#define  HS_BTT_XSCJ		  2
/// ɽ
#define  HS_BTT_DJCJ		  3
/// ѯ۳ɽ
#define  HS_BTT_XJCJ		  4
/// ɽ
#define  HS_BTT_JMCJ          5
/// 걨
#define  HS_BTT_YXSB          6
/// ƥɽ
#define  HS_BTT_PPDE          7
/// Ѻʽƥɽ
#define  HS_BTT_ZYPPCJ        8
/// δ֪
#define  HS_BTT_UNKNOWN       0
typedef int8    HSBondTradeType;

//////////////////////////////////////////////////////////////////////////
/// HSBondBidExecInstTypeծȯɽʽ
//////////////////////////////////////////////////////////////////////////
/// һб
#define  HS_BEIT_DYZT		  1
/// 嵥һ۸
#define  HS_BEIT_DZTDYJ		  2
/// ؼ۸
#define  HS_BEIT_DZTDCJ		  3
/// δ֪
#define  HS_BEIT_UNKNOWN      0
typedef int16   HSBondBidExecInstType;

//////////////////////////////////////////////////////////////////////////
/// HSSecondaryOrderID򳡴α
//////////////////////////////////////////////////////////////////////////
typedef char	HSSecondaryOrderID[17];

//////////////////////////////////////////////////////////////////////////
/// HSBondMemoծȯױע
//////////////////////////////////////////////////////////////////////////
typedef char	HSBondMemo[161];

//////////////////////////////////////////////////////////////////////////
/// HSBondBidTransTypeծȯҵ
//////////////////////////////////////////////////////////////////////////
/// ԤԼ걨
#define  HS_BBTT_YYSB		  1
/// 걨
#define  HS_BBTT_FQSB		  2
/// Ӧ걨
#define  HS_BBTT_YJSB		  3
/// δ֪
#define  HS_BBTT_UNKNOWN      0
typedef int16   HSBondBidTransType;

//////////////////////////////////////////////////////////////////////////
/// HSRebuildTransTypeؽ
//////////////////////////////////////////////////////////////////////////
/// ʳɽ
#define HS_RTT_Trade	          '1'
/// ί
#define HS_RTT_Entrust            '2'
/// ծȯʳɽ
#define HS_RTT_BOND_Trade         '3'
/// ծȯί
#define HS_RTT_BOND_Entrust       '4'
typedef char HSRebuildTransType;

//////////////////////////////////////////////////////////////////////////
/// HSSeatIDϯλ
//////////////////////////////////////////////////////////////////////////
typedef char HSSeatID[17];

//////////////////////////////////////////////////////////////////////////
/// HSSeatIndexϯλ
//////////////////////////////////////////////////////////////////////////
typedef uint32 HSSeatIndex;

//////////////////////////////////////////////////////////////////////////
/// HSSelfCloseTypeԳ
//////////////////////////////////////////////////////////////////////////
typedef char HSSelfCloseType;

//////////////////////////////////////////////////////////////////////////
/// HSSetSelfCloseTypeԳò
//////////////////////////////////////////////////////////////////////////
typedef char HSSetSelfCloseType;

//////////////////////////////////////////////////////////////////////////
/// HSCertID֤ʶ
//////////////////////////////////////////////////////////////////////////
typedef char HSCertID[50];

//////////////////////////////////////////////////////////////////////////
/// HSDeviceID豸ʶ
//////////////////////////////////////////////////////////////////////////
typedef char HSDeviceID[100];

//////////////////////////////////////////////////////////////////////////
/// HSCertInfo֤Ϣ
//////////////////////////////////////////////////////////////////////////
typedef char HSCertInfo[1024];

//////////////////////////////////////////////////////////////////////////
/// HSIsCurrentǷݲ
//////////////////////////////////////////////////////////////////////////
typedef int HSIsCurrent;

//////////////////////////////////////////////////////////////////////////
/// HSSksPin֤pin
//////////////////////////////////////////////////////////////////////////
typedef char HSSksPin[32];

//////////////////////////////////////////////////////////////////////////
/// HSSksServer̵ַ֤
//////////////////////////////////////////////////////////////////////////
typedef char HSSksServer[64];

//////////////////////////////////////////////////////////////////////////
/// HSSksUser֤û
//////////////////////////////////////////////////////////////////////////
typedef char HSSksUser[32];

//////////////////////////////////////////////////////////////////////////
/// HSSksPassword֤
//////////////////////////////////////////////////////////////////////////
typedef char HSSksPassword[32];

//////////////////////////////////////////////////////////////////////////
/// HSSksCheckCertFlag̸֤֤У
//////////////////////////////////////////////////////////////////////////
/// и֤У
#define HS_SCC_UnCheck	'0'
/// и֤У
#define HS_SCC_Check	'1'
typedef char HSSksCheckCertFlag;

//////////////////////////////////////////////////////////////////////////
/// HSErrorLog:Ϣ
////////////////////////////////////////////////////////////////////////// 
typedef char HSErrorLog[6000];

//////////////////////////////////////////////////////////////////////////
/// HSRelationName:ϵ
//////////////////////////////////////////////////////////////////////////
typedef char HSRelationName[121];

//////////////////////////////////////////////////////////////////////////
/// HSRelationTel:ϵ˵绰
//////////////////////////////////////////////////////////////////////////
typedef char HSRelationTel[33];

//////////////////////////////////////////////////////////////////////////
/// HSPropSeatNo:Էϯλ
//////////////////////////////////////////////////////////////////////////
typedef char HSPropSeatNo[9];

//////////////////////////////////////////////////////////////////////////
/// HSConferId:Լ
//////////////////////////////////////////////////////////////////////////
typedef char HSConferId[11];

//////////////////////////////////////////////////////////////////////////
/// HSNationality:
//////////////////////////////////////////////////////////////////////////
typedef char HSNationality[4];

//////////////////////////////////////////////////////////////////////////
/// HSAddress:ַ
//////////////////////////////////////////////////////////////////////////
typedef char HSAddress[121];

//////////////////////////////////////////////////////////////////////////
/// HSName:
//////////////////////////////////////////////////////////////////////////
typedef char HSName[65];

//////////////////////////////////////////////////////////////////////////
/// HSOrganName:
//////////////////////////////////////////////////////////////////////////
typedef char HSOrganName[61];

//////////////////////////////////////////////////////////////////////////
/// HSGroupName:
//////////////////////////////////////////////////////////////////////////
typedef char HSGroupName[13];

//////////////////////////////////////////////////////////////////////////
/// HSTelCode:ϵ绰
//////////////////////////////////////////////////////////////////////////
typedef char HSTelCode[21];

//////////////////////////////////////////////////////////////////////////
/// HSTriggerFlag:־
//////////////////////////////////////////////////////////////////////////
//δ
#define   HS_TF_NoRisk                       '0'  
//
#define   HS_TF_Alert                        '1' 
typedef char HSTriggerFlag;

//////////////////////////////////////////////////////////////////////////
/// HsRiskContent:Ϣ
//////////////////////////////////////////////////////////////////////////
typedef char HSRiskContent[513];

//////////////////////////////////////////////////////////////////////////
/// HSRiskName:
//////////////////////////////////////////////////////////////////////////
typedef char HSArcsName[121];

//////////////////////////////////////////////////////////////////////////
/// HsClientName:ͻ
//////////////////////////////////////////////////////////////////////////
typedef char HSClientName[257];

//////////////////////////////////////////////////////////////////////////
/// HSBTradeconferId:Լ
//////////////////////////////////////////////////////////////////////////
typedef char HSBTradeconferId[11];

//////////////////////////////////////////////////////////////////////////
/// HSEtfComponentCode:ɷֹɴ
//////////////////////////////////////////////////////////////////////////
typedef char HSEtfComponentCode[21];

//////////////////////////////////////////////////////////////////////////
/// HSLockStockQuoteIDȯ(滥ȯҵ)
//////////////////////////////////////////////////////////////////////////
typedef char HSLockStockQuoteID[33];

//////////////////////////////////////////////////////////////////////////
/// HSLockCompactStatusȯԼ״̬(滥ȯҵ)
//////////////////////////////////////////////////////////////////////////
/// ԼδЧ
#define HS_LCS_InEffective	'0'
/// ԼЧ
#define HS_LCS_Effective	'1'
/// ԼʧЧ
#define HS_LCS_Expired		'2'
typedef char HSLockCompactStatus;

//////////////////////////////////////////////////////////////////////////
/// HSEarlyRecallModeǰٻģʽ(滥ȯҵ)
//////////////////////////////////////////////////////////////////////////
/// ٻ
#define HS_ERM_NoRecall	'0'
/// T+0
#define HS_ERM_Today	'1'
/// T+1
#define HS_ERM_Morrow	'2'
typedef char HSEarlyRecallMode;

/////////////////////////////////////////////////////////////////////////
/// HSTickStatusFlagϺʲƷ״̬״̬ʶ
/////////////////////////////////////////////////////////////////////////
/// Ʒδ
#define HS_TSF_ADD           '1'
/// 
#define HS_TSF_START         '2'
/// мϾ
#define HS_TSF_OCALL         '3'
/// Զ
#define HS_TSF_TRADE         '4'
/// ͣ
#define HS_TSF_SUSP          '5'
/// ̼Ͼ
#define HS_TSF_CCALL         '6'
/// 
#define HS_TSF_CLOSE         '7'
/// ׽
#define HS_TSF_ENDTR         '8'
typedef char HSTickStatusFlag;

//////////////////////////////////////////////////////////////////////////
/// HSCombStrategyNameϲ
//////////////////////////////////////////////////////////////////////////
typedef char HSCombStrategyName[128];

#endif
