/**
* @author ٺط
* @company ӹɷ޹˾
* @file HSMdApi.h
* @brief ӿ
* @date    20170927
*/
#ifndef _HS_MD_API_H_
#define _HS_MD_API_H_

#include "HSStruct.h"


#ifdef WIN32
    #define MD_API_EXPORT 
#else
    #ifdef HSMDAPI_EXPORTS
        #define MD_API_EXPORT __attribute__((visibility("default"))) 
    #else
        #define MD_API_EXPORT
    #endif
#endif

///ص
class CHSMdSpi
{
public:
    /// Description: ͻ뽻׺̨ʼͨӣӳɹ˷ص
    virtual void OnFrontConnected(){};

    /// Description:ͻ뽻׺̨ͨ쳣ʱ÷á
    /// Others     :ͨGetApiErrorMsg(nResult)ȡϸϢ
    virtual void OnFrontDisconnected(int nResult){};

    /// Description: -Ӧ
    virtual void OnRspDepthMarketDataSubscribe(CHSRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

    /// Description: ȡ-Ӧ
    virtual void OnRspDepthMarketDataCancel(CHSRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

    /// Description: -
    virtual void OnRtnDepthMarketData(CHSDepthMarketDataField *pDepthMarketData) {};

    /// Description: -ѯӦ
    virtual void OnRspForQuoteSubscribe(CHSRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

    /// Description: ȡ-ѯӦ
    virtual void OnRspForQuoteCancel(CHSRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

    /// Description: -ѯ
    virtual void OnRtnForQuote(CHSForQuoteField *pForQuote) {};

};

///
class CHSMdApi
{
public:
    /// Description: ɾӿڶ
    virtual void ReleaseApi() = 0;

    /// Description: ʼ
    ///              pInitCfgField            ʼ
    ///              pExtraParam              ʼ
    virtual int Init(const CHSInitConfigField *pInitCfgField, void* pExtraParam = (void*)0) = 0;

    /// Description: APIͽ׹̨ӣӽɹ̻߳ȴû߳˳
    /// Return     int 0ʾӽɹʾʧܣͨGetApiErrorMsgԻȡϸϢ
    virtual int Join() = 0;

    /// Description: עǰûַ
    /// Input      : pszFrontAddress            ǰûַ  磺tcp://127.0.0.1:17001
    /// Return     : int 0ʾóɹʾʧܣͨGetApiErrorMsgԻȡϸϢ
    virtual int RegisterFront(const char *pszFrontAddress) = 0;

    /// Description: עFensַ
    /// Input      : pszFensAddress            Fensַ
    /// Input      : pszAccountID              ˺
    /// Return     : int 0ʾóɹʾʧܣͨGetApiErrorMsgԻȡϸϢ
    virtual int RegisterFensServer(const char *pszFensAddress, const char *pszAccountID) = 0;

    /// Description: עصӿ
    /// Input      : pSpi            Իصӿʵ     
    virtual void RegisterSpi(CHSMdSpi *pSpi) = 0;

    /// Description: -
    /// Input      : pReqDepthMarketDataSubscribe[]        鶩ṹ 
    ///              nCount                                Լ
    ///              nRequestID                             
    virtual int ReqDepthMarketDataSubscribe(CHSReqDepthMarketDataField pReqDepthMarketDataSubscribe[], int nCount, int nRequestID) = 0;

    /// Description: ȡ-
    /// Input      : pReqDepthMarketDataCancel[]        鶩ȡṹ 
    ///              nCount                             ȡԼ
    ///              nRequestID                          
    virtual int ReqDepthMarketDataCancel(CHSReqDepthMarketDataField pReqDepthMarketDataCancel[], int nCount, int nRequestID) = 0;

    /// Description: -ѯ
    /// Input      : pReqForQuoteSubscribe[]               ѯ۶ṹ 
    ///              nCount                                ѯۺԼ
    ///              nRequestID                             
    virtual int ReqForQuoteSubscribe(CHSReqForQuoteField pReqForQuoteSubscribe[], int nCount, int nRequestID) = 0;

    /// Description: ȡ-ѯ
    /// Input      : pReqForQuoteCancel[]                  ѯ۶ȡṹ 
    ///              nCount                                ȡѯۺԼ
    ///              nRequestID                            
    virtual int ReqForQuoteCancel(CHSReqForQuoteField pReqForQuoteCancel[], int nCount, int nRequestID) = 0;

    ///////////////////////////////////////////////////////////////////////////////////////
    /// Description: ôϸϢ
    /// Input      : nErrorCode            
    /// Return     Ϣ
    ///////////////////////////////////////////////////////////////////////////////////////
    virtual const char* GetApiErrorMsg(int nErrorCode) = 0;

protected:
    ~CHSMdApi(){};
 };
#ifdef __cplusplus
extern "C"
{
#endif
    /// Description: ȡAPI汾
    /// Return     : API汾
    const char* GetMdApiVersion();

    /// Description: ӿ
    /// Input      : pszFlowPath    ־·   
    CHSMdApi* NewMdApi(const char *pszFlowPath);

#ifdef __cplusplus
}
#endif
#endif
