#ifndef __HSSMCERTSDK_H
#define __HSSMCERTSDK_H
#include <stdlib.h>

#ifdef _WIN32
    #define SM_CERT_EXPORT
#else
    #ifdef HSTRADEAPI_EXPORTS
        #define SM_CERT_EXPORT __attribute__((visibility("default"))) 
    #else
        #define SM_CERT_EXPORT
    #endif
#endif

/* Эͬǩö */
struct HSGMCertUserConfig
{
    char  UserAccount[32];          /* ûAccount */
    char  UserPin[32];              /* ûıPIN */
    char  UserPassword[32];         /* û룬û֤У */
    char  ServerIP[64];             /* Эͬǩַ */
    char  Version[16];              /* ܳ  :gergmssl  Ű:xasjgmssl ָ*/
};

/* ֤Ϣ */
struct HSSMCert
{
    char CertID[50];      /* ֤ΨһʶֶΪԶΨһʶΪû֤Ψһ֤ʶ*/
    char UserAccount[32]; /* ûIDֶΪʱUserID */
    char CertInfo[1024];  /* ֤ϢֶΪ֤֤⣬֤ÿֶμ'/'ָ
                            ն˿ȡͶӦֵչʾ
                            user_cert_cid         ֤Ψһʶ
                            subject_common_name   ûID
                            term_desc             豸ʶ
                            cert_last_use_time    ʹʱ
                            user_cert_not_before  ʼ
                            user_cert_not_after   ֹ
                            */
};

//֤
class CHSSMCertApi
{
public:
    /**
     * @brief ʼ֤
     * 
     *
     * @param config  [in] û
     * @return int    ɹ 0
     *                ʧܷش
     */
    virtual int Init(const HSGMCertUserConfig* pUserConfig) = 0;

    /**
     * @brief ͷŴ֤Ķ
     *
     * @param  [in] Conn Ӷ
     * @param  [in] CertMgr ֤
     * @param  [in] pCert Ÿû֤Ķ
     * @return int  ɹ 0
     *              ʧܷش
     */
    virtual void Release() = 0;

    /**
     * @brief ݴȡϸϢ
     * 
     * @param [in]  nErrorCode 룬֤ر֤֤ڡٲķֵ
     * @return const char*  ɹشϢ
     */
    virtual const char* GetSMErrorMsg(int nErrorCode) = 0;

    /**
     * @brief û֤飬ûPIN룬PIN볤ȲС6λ
     *
     * Ч֤飬APIУPIN
     * PINУʧܣش
     * Ч֤飬ֱӼǩ֤
     *
     * Ч֤ʱ̨Уû
     * ̨УUserPasswordʧܣش
     * ̨УUserPasswordɹǩ֤
     *
     * @return int   ɹ 0
     *               ʧܷش
     *
     */
    virtual int ReqCertEnroll() = 0;

    /**
     * @brief ڱ豸û֤
     *
     * ̨Уû
     * ̨УUserPasswordʧܣش
     * ̨УUserPasswordɹſԼ֤顣
     *
     * @return int  ɹ 0
     *              ʧܷش
     *
     */
    virtual int ReqCertDelay() = 0;

    /**
    * @brief ϳ豸û֤
    *
    * ̨Уû
    * ̨УUserPasswordʧܣش
    * ̨УUserPasswordɹſԼϳ豸û֤顣
    *
    * @return int  ɹ 0
    *              ʧܷش
    *
    */
    virtual int ReqCertRevoke() = 0;

    /**
     * @brief CertIDû֤
     *
     * ̨Уû
     * ̨УPASSWORDʧܣش
     * ̨УPASSWORDɹſԼ֤顣
     * 
     * @param [in]  CertID ֤Ψһʶ
     * @return int   ɹ 0
     *               ʧܷش
     *
     */
    virtual int ReqCertRevokeByID(const char* pszCertID) = 0;

    /**
     * @brief PIN
     *
     * ̨Уû
     * ̨УPASSWORDʧܣش
     * ̨УPASSWORDɹſɼPIN
     *
     * УɵPINֻñ֤PIN 
     *
     * @param [in]  NewPIN µPIN
     * @return int  ɹ 0
     *              ʧܷش
     *
     */
    virtual int ReqResetPin(const char* pszNewPIN) = 0;

    /**
     * @brief ѯûЧ֤Ϣ
     *
     * ûڵ¼֮ǰãѯԼ֤飬Ը̨֪Ա֤Ϣע֤顣
     * ̨Уû
     * ̨УUserPasswordʧܣش
     * ̨УUserPasswordɹſԼѯ֤顣
     *
     * pCertָָڴ棬APIڲ
     *
     * @param [out] pCert Ÿû֤Ķ
     * @param [out] count û֤
     * @return int
     *
     */
    virtual int ReqCertQuery(HSSMCert** pCert, int* count) = 0;
};

#ifdef __cplusplus
extern "C" {
#endif 
    /**
     * @brief ȡ֤ӿڰ汾
     */
    SM_CERT_EXPORT const char* GetSMCertApiVersion();

    /**
     * @brief ֤ӿ
     */
    SM_CERT_EXPORT CHSSMCertApi* NewSMCertApi(const char* pszFlowPath);

#ifdef __cplusplus
}
#endif
#endif